Index: test/park_integration/test/utest_fit_cylinder.py
===================================================================
--- test/park_integration/test/utest_fit_cylinder.py	(revision eff93b8d577de85b34ffd99e484da07484c35580)
+++ test/park_integration/test/utest_fit_cylinder.py	(revision eff93b8d577de85b34ffd99e484da07484c35580)
@@ -0,0 +1,137 @@
+"""
+    Unit tests for fitting module 
+    @author G.alina
+"""
+import unittest
+import math
+
+from sans.fit.AbstractFitEngine import Model
+from sans.fit.Fitting import Fit
+from sans.dataloader.loader import Loader
+
+#@unittest.skip("")
+class TestSingleFit(unittest.TestCase):
+    """ test single fitting """
+    def setUp(self):
+        """ initialize data"""
+        self.data = Loader().load("cyl_400_20.txt")
+        # Create model that fitting engine understands
+        from sans.models.CylinderModel import CylinderModel
+        self.model  = CylinderModel()
+        self.model.setParam("scale", 1.0)
+        self.model.setParam("radius",18)
+        self.model.setParam("length", 397)
+        self.model.setParam("sldCyl",3e-006 )
+        self.model.setParam("sldSolv",0.0 )
+        self.model.setParam("background", 0.0)
+        #select parameters to fit
+        self.pars1 =['length','radius','scale']
+        
+    def _fit(self, name="scipy"):
+        """ return fit result """
+        fitter = Fit(name)
+        fitter.set_data(self.data,1)
+        fitter.set_model(self.model,1,self.pars1)
+        fitter.select_problem_for_fit(id=1,value=1)
+        result1, = fitter.fit()
+
+        self.assert_(result1)
+        self.assertTrue(len(result1.pvec)>0 or len(result1.pvec)==0 )
+        self.assertTrue(len(result1.stderr)> 0 or len(result1.stderr)==0)
+
+        self.assertTrue( math.fabs(result1.pvec[0]-400.0)/3.0 < result1.stderr[0] )
+        self.assertTrue( math.fabs(result1.pvec[1]-20.0)/3.0  < result1.stderr[1] )
+        self.assertTrue( math.fabs(result1.pvec[2]-1.0)/3.0   < result1.stderr[2] )
+        self.assertTrue( result1.fitness < 1.0 )
+
+
+    def test_scipy(self):
+        """ Simple cylinder model fit (scipy)  """
+        self._fit("scipy")
+
+
+    def test_park(self):
+        """ Simple cylinder model fit (park)  """
+        self._fit("park")
+
+    def test_bumps(self):
+        """ Simple cylinder model fit (park)  """
+        self._fit("bumps")
+
+
+        
+class TestSimultaneousFit(unittest.TestCase):
+    """ test simultaneous fitting """
+    def setUp(self):
+        """ initialize data"""
+        
+        self.data1=Loader().load("cyl_400_20.txt")
+        self.data2=Loader().load("cyl_400_40.txt")
+    
+        # Receives the type of model for the fitting
+        from sans.models.CylinderModel import CylinderModel
+        cyl1  = CylinderModel()
+        cyl1.name = "C1"
+        self.model1 = Model(cyl1)
+        self.model1.set(scale= 1.0)
+        self.model1.set(radius=18)
+        self.model1.set(length=200)
+        self.model1.set(sldCyl=3e-006, sldSolv=0.0)
+        self.model1.set(background=0.0)
+
+        cyl2  = CylinderModel()
+        cyl2.name = "C2"
+        self.model2 = Model(cyl2)
+        self.model2.set(scale= 1.0)
+        self.model2.set(radius=37)
+        self.model2.set(length=300)
+        self.model2.set(sldCyl=3e-006, sldSolv=0.0)
+        self.model2.set(background=0.0)
+
+
+    def test_constrained_bumps(self):
+        """ Simultaneous cylinder model fit (park)  """
+        self._run_fit(Fit('bumps'))
+
+    #@unittest.skip("")
+    def test_constrained_park(self):
+        """ Simultaneous cylinder model fit (park)  """
+        self._run_fit(Fit('park'))
+
+    def _run_fit(self, fitter):
+        result1, result2 = self._fit(fitter)
+        self.assert_(result1)
+        self.assertTrue(len(result1.pvec)>0)
+        self.assertTrue(len(result1.stderr)>0)
+
+        for n, v, dv in zip(result1.param_list, result1.pvec, result1.stderr):
+            print "%s M1.%s = %s +/- %s"%(fitter._engine.__class__.__name__,n,v,dv)
+            if n == "length":
+                self.assertTrue( math.fabs(v-400.0)/3.0 < dv )
+            elif n=='radius':
+                self.assertTrue( math.fabs(v-20.0)/3.0 < dv )
+            elif n=='scale':
+                self.assertTrue( math.fabs(v-1.0)/3.0 < dv )
+        for n, v, dv in zip(result2.param_list, result2.pvec, result2.stderr):
+            print "%s M2.%s = %s +/- %s"%(fitter._engine.__class__.__name__,n,v,dv)
+            if n=='radius':
+                self.assertTrue( math.fabs(v-40.0)/3.0 < dv )
+            elif n=='scale':
+                self.assertTrue( math.fabs(v-1.0)/3.0 < dv )
+
+    def _fit(self, fitter):
+        """ return fit result """
+        fitter.set_data(self.data1,1)
+        fitter.set_model(self.model1, 1, ['length','radius','scale'])
+
+        fitter.set_data(self.data2,2)
+        fitter.set_model(self.model2, 2, ['length','radius','scale'],
+                         constraints=[("length","C1.length")])
+        fitter.select_problem_for_fit(id=1,value=1)
+        fitter.select_problem_for_fit(id=2,value=1)
+        return fitter.fit()
+
+
+if __name__ == '__main__':
+    unittest.main()        
+       
Index: test/park_integration/test/utest_fit_line.py
===================================================================
--- test/park_integration/test/utest_fit_line.py	(revision e3efa6b33f61b244c04b2476cabdadf01a183b76)
+++ test/park_integration/test/utest_fit_line.py	(revision e3efa6b33f61b244c04b2476cabdadf01a183b76)
@@ -0,0 +1,257 @@
+"""
+    Unit tests for fitting module 
+    @author Gervaise Alina
+"""
+import unittest
+import math
+
+from sans.fit.AbstractFitEngine import Model, FitHandler
+from sans.dataloader.loader import Loader
+from sans.fit.Fitting import Fit
+from sans.models.LineModel import LineModel
+from sans.models.Constant import Constant
+
+class testFitModule(unittest.TestCase):
+    """ test fitting """
+
+    def test_bad_pars(self):
+        fitter = Fit('bumps')
+
+        data = Loader().load("testdata_line.txt")
+        data.name = data.filename
+        fitter.set_data(data,1)
+
+        model1  = LineModel()
+        model1.name = "M1"
+        model = Model(model1, data)
+        pars1= ['param1','param2']
+        try:
+            fitter.set_model(model,1,pars1)
+        except ValueError,exc:
+            #print "ValueError was correctly raised: "+str(msg)
+            assert str(exc).startswith('parameter param1')
+        else:
+            raise AssertionError("No error raised for scipy fitting with wrong parameters name to fit")
+
+    def fit_single(self, fitter_name, isdream=False):
+        fitter = Fit(fitter_name)
+
+        data = Loader().load("testdata_line.txt")
+        data.name = data.filename
+        fitter.set_data(data,1)
+
+        # Receives the type of model for the fitting
+        model1  = LineModel()
+        model1.name = "M1"
+        model = Model(model1,data)
+        #fit with scipy test
+
+        pars1= ['A','B']
+        fitter.set_model(model,1,pars1)
+        fitter.select_problem_for_fit(id=1,value=1)
+        result1, = fitter.fit(handler=FitHandler())
+
+        # The target values were generated from the following statements
+        p,s,fx = result1.pvec, result1.stderr, result1.fitness
+        #print "p0,p1,s0,s1,fx = %g, %g, %g, %g, %g"%(p[0],p[1],s[0],s[1],fx)
+        p0,p1,s0,s1,fx_ = 3.68353, 2.61004, 0.336186, 0.105244, 1.20189
+
+        if isdream:
+            # Dream is not a minimizer: just check that the fit is within
+            # uncertainty
+            self.assertTrue( abs(p[0]-p0) <= s0 )
+            self.assertTrue( abs(p[1]-p1) <= s1 )
+        else:
+            self.assertTrue( abs(p[0]-p0) <= 1e-5 )
+            self.assertTrue( abs(p[1]-p1) <= 1e-5 )
+            self.assertTrue( abs(fx-fx_) <= 1e-5 )
+
+    def fit_bumps(self, alg, **opts):
+        #Importing the Fit module
+        from bumps import fitters
+        fitters.FIT_DEFAULT = alg
+        fitters.FIT_OPTIONS[alg].options.update(opts)
+        fitters.FIT_OPTIONS[alg].options.update(monitors=[])
+        #print "fitting",alg,opts
+        #kprint "options",fitters.FIT_OPTIONS[alg].__dict__
+        self.fit_single('bumps', isdream=(alg=='dream'))
+
+    def test_bumps_de(self):
+        self.fit_bumps('de')
+
+    def test_bumps_dream(self):
+        self.fit_bumps('dream', burn=500, steps=100)
+
+    def test_bumps_amoeba(self):
+        self.fit_bumps('amoeba')
+
+    def test_bumps_newton(self):
+        self.fit_bumps('newton')
+
+    def test_bumps_lm(self):
+        self.fit_bumps('lm')
+
+    def test_scipy(self):
+        #print "fitting scipy"
+        self.fit_single('scipy')
+
+    def test_park(self):
+        #print "fitting park"
+        self.fit_single('park')
+
+        
+    def test2(self):
+        """ fit 2 data and 2 model with no constrainst"""
+        #load data
+        l = Loader()
+        data1=l.load("testdata_line.txt")
+        data1.name = data1.filename
+      
+        data2=l.load("testdata_line1.txt")
+        data2.name = data2.filename
+     
+        #Importing the Fit module
+        fitter = Fit('scipy')
+        # Receives the type of model for the fitting
+        model11  = LineModel()
+        model11.name= "M1"
+        model22  = LineModel()
+        model11.name= "M2"
+      
+        model1 = Model(model11,data1)
+        model2 = Model(model22,data2)
+        #fit with scipy test
+        pars1= ['A','B']
+        fitter.set_data(data1,1)
+        fitter.set_model(model1,1,pars1)
+        fitter.select_problem_for_fit(id=1,value=0)
+        fitter.set_data(data2,2)
+        fitter.set_model(model2,2,pars1)
+        fitter.select_problem_for_fit(id=2,value=0)
+        
+        try: result1, = fitter.fit(handler=FitHandler())
+        except RuntimeError,msg:
+           assert str(msg)=="No Assembly scheduled for Scipy fitting."
+        else: raise AssertionError,"No error raised for scipy fitting with no model"
+        fitter.select_problem_for_fit(id=1,value=1)
+        fitter.select_problem_for_fit(id=2,value=1)
+        try: result1, = fitter.fit(handler=FitHandler())
+        except RuntimeError,msg:
+           assert str(msg)=="Scipy can't fit more than a single fit problem at a time."
+        else: raise AssertionError,"No error raised for scipy fitting with more than 2 models"
+
+        #fit with park test
+        fitter = Fit('park')
+        fitter.set_data(data1,1)
+        fitter.set_model(model1,1,pars1)
+        fitter.set_data(data2,2)
+        fitter.set_model(model2,2,pars1)
+        fitter.select_problem_for_fit(id=1,value=1)
+        fitter.select_problem_for_fit(id=2,value=1)
+        R1,R2 = fitter.fit(handler=FitHandler())
+        
+        self.assertTrue( math.fabs(R1.pvec[0]-4)/3 <= R1.stderr[0] )
+        self.assertTrue( math.fabs(R1.pvec[1]-2.5)/3 <= R1.stderr[1] )
+        self.assertTrue( R1.fitness/(len(data1.x)+len(data2.x)) < 2)
+        
+        
+    def test3(self):
+        """ fit 2 data and 2 model with 1 constrainst"""
+        #load data
+        l = Loader()
+        data1= l.load("testdata_line.txt")
+        data1.name = data1.filename
+        data2= l.load("testdata_cst.txt")
+        data2.name = data2.filename
+       
+        # Receives the type of model for the fitting
+        model11  = LineModel()
+        model11.name= "line"
+        model11.setParam("A", 1.0)
+        model11.setParam("B",1.0)
+        
+        model22  = Constant()
+        model22.name= "cst"
+        model22.setParam("value", 1.0)
+        
+        model1 = Model(model11,data1)
+        model2 = Model(model22,data2)
+        model1.set(A=4)
+        model1.set(B=3)
+        # Constraint the constant value to be equal to parameter B (the real value is 2.5)
+        model2.set(value='line.B')
+        #fit with scipy test
+        pars1= ['A','B']
+        pars2= ['value']
+        
+        #Importing the Fit module
+        fitter = Fit('park')
+        fitter.set_data(data1,1)
+        fitter.set_model(model1,1,pars1)
+        fitter.set_data(data2,2,smearer=None)
+        fitter.set_model(model2,2,pars2)
+        fitter.select_problem_for_fit(id=1,value=1)
+        fitter.select_problem_for_fit(id=2,value=1)
+        
+        R1,R2 = fitter.fit(handler=FitHandler())
+        self.assertTrue( math.fabs(R1.pvec[0]-4.0)/3. <= R1.stderr[0])
+        self.assertTrue( math.fabs(R1.pvec[1]-2.5)/3. <= R1.stderr[1])
+        self.assertTrue( R1.fitness/(len(data1.x)+len(data2.x)) < 2)
+        
+        
+    def test4(self):
+        """ fit 2 data concatenates with limited range of x and  one model """
+            #load data
+        l = Loader()
+        data1 = l.load("testdata_line.txt")
+        data1.name = data1.filename
+        data2 = l.load("testdata_line1.txt")
+        data2.name = data2.filename
+
+        # Receives the type of model for the fitting
+        model1  = LineModel()
+        model1.name= "M1"
+        model1.setParam("A", 1.0)
+        model1.setParam("B",1.0)
+        model = Model(model1,data1)
+      
+        #fit with scipy test
+        pars1= ['A','B']
+        #Importing the Fit module
+        fitter = Fit('scipy')
+        fitter.set_data(data1,1,qmin=0, qmax=7)
+        fitter.set_model(model,1,pars1)
+        fitter.set_data(data2,1,qmin=1,qmax=10)
+        fitter.select_problem_for_fit(id=1,value=1)
+        
+        result1, = fitter.fit(handler=FitHandler())
+        #print(result1)
+        self.assert_(result1)
+
+        self.assertTrue( math.fabs(result1.pvec[0]-4)/3 <= result1.stderr[0] )
+        self.assertTrue( math.fabs(result1.pvec[1]-2.5)/3 <= result1.stderr[1])
+        self.assertTrue( result1.fitness/len(data1.x) < 2 )
+
+        #fit with park test
+        fitter = Fit('park')
+        fitter.set_data(data1,1,qmin=0, qmax=7)
+        fitter.set_model(model,1,pars1)
+        fitter.set_data(data2,1,qmin=1,qmax=10)
+        fitter.select_problem_for_fit(id=1,value=1)
+        result2, = fitter.fit(handler=FitHandler())
+        
+        self.assert_(result2)
+        self.assertTrue( math.fabs(result2.pvec[0]-4)/3 <= result2.stderr[0] )
+        self.assertTrue( math.fabs(result2.pvec[1]-2.5)/3 <= result2.stderr[1] )
+        self.assertTrue( result2.fitness/len(data1.x) < 2)
+        # compare fit result result for scipy and park
+        self.assertAlmostEquals( result1.pvec[0], result2.pvec[0] )
+        self.assertAlmostEquals( result1.pvec[1],result2.pvec[1] )
+        self.assertAlmostEquals( result1.stderr[0],result2.stderr[0] )
+        self.assertAlmostEquals( result1.stderr[1],result2.stderr[1] )
+        self.assertTrue( result2.fitness/(len(data2.x)+len(data1.x)) < 2 )
+
+
+if __name__ == "__main__":
+    unittest.main()
+    
Index: test/park_integration/test/utest_fit_smeared.py
===================================================================
--- test/park_integration/test/utest_fit_smeared.py	(revision e3efa6b33f61b244c04b2476cabdadf01a183b76)
+++ test/park_integration/test/utest_fit_smeared.py	(revision e3efa6b33f61b244c04b2476cabdadf01a183b76)
@@ -0,0 +1,204 @@
+"""
+    Unit tests for fitting module 
+    @author M. Doucet
+"""
+import unittest
+import math
+
+import numpy
+from sans.fit.AbstractFitEngine import Model
+from sans.fit.Fitting import Fit
+from sans.dataloader.loader import Loader
+from sans.models.qsmearing import smear_selection
+from sans.models.CylinderModel import CylinderModel
+from sans.models.SphereModel import SphereModel
+
+class testFitModule(unittest.TestCase):
+    """ test fitting """
+    
+    def test_scipy(self):
+        """ Simple cylinder model fit (scipy)  """
+        
+        out=Loader().load("cyl_400_20.txt")
+        # This data file has not error, add them
+        #out.dy = out.y
+        
+        fitter = Fit('scipy')
+        fitter.set_data(out,1)
+        
+        # Receives the type of model for the fitting
+        model1  = CylinderModel()
+        model1.setParam("scale", 1.0)
+        model1.setParam("radius",18)
+        model1.setParam("length", 397)
+        model1.setParam("sldCyl",3e-006 )
+        model1.setParam("sldSolv",0.0 )
+        model1.setParam("background", 0.0)
+        model = Model(model1)
+        pars1 =['length','radius','scale']
+        fitter.set_model(model,1,pars1)
+        
+        # What the hell is this line for?
+        fitter.select_problem_for_fit(id=1,value=1)
+        result1, = fitter.fit()
+        #print "result1",result1
+
+        self.assert_(result1)
+        self.assertTrue(len(result1.pvec) > 0)
+        self.assertTrue(len(result1.stderr) > 0)
+        
+        self.assertTrue( math.fabs(result1.pvec[0]-400.0)/3.0 < result1.stderr[0] )
+        self.assertTrue( math.fabs(result1.pvec[1]-20.0)/3.0  < result1.stderr[1] )
+        self.assertTrue( math.fabs(result1.pvec[2]-1)/3.0   < result1.stderr[2] )
+        self.assertTrue( result1.fitness < 1.0 )
+
+    def test_park_dispersion(self):
+        """
+            Cylinder fit with dispersion
+        """
+        self._dispersion(fitter = Fit('park'))
+
+    def test_bumps_dispersion(self):
+        """
+            Cylinder fit with dispersion
+        """
+        alg = 'lm'
+        from bumps import fitters
+        fitters.FIT_DEFAULT = alg
+        #fitters.FIT_OPTIONS[alg].options.update(opts)
+        fitters.FIT_OPTIONS[alg].options.update(monitors=[])
+        self._dispersion(fitter = Fit('bumps'))
+
+    def test_scipy_dispersion(self):
+        """
+            Cylinder fit with dispersion
+        """
+        self._dispersion(fitter = Fit('scipy'))
+
+    def _dispersion(self, fitter):
+        # Load data
+        # This data is for a cylinder with 
+        #   length=400, radius=20, radius disp=5, scale=1e-10
+        out=Loader().load("cyl_400_20_disp5r.txt")
+        out.dy = numpy.zeros(len(out.y))
+        for i in range(len(out.y)):
+            out.dy[i] = math.sqrt(out.y[i])
+        
+        # Receives the type of model for the fitting
+        model1  = CylinderModel()
+        model1.setParam("scale", 10.0)
+        model1.setParam("radius",18)
+        model1.setParam("length", 397)
+        model1.setParam("sldCyl",3e-006 )
+        model1.setParam("sldSolv",0.0 )
+        model1.setParam("background", 0.0)
+
+        # Dispersion parameters
+        model1.dispersion['radius']['width'] = 0.25
+        model1.dispersion['radius']['npts'] = 50
+
+        model = Model(model1)
+
+        pars1 =['length','radius','scale','radius.width']
+        fitter.set_data(out,1)
+        fitter.set_model(model,1,pars1)
+        fitter.select_problem_for_fit(id=1,value=1)
+        #import time; T0 = time.time()
+        result1, = fitter.fit()
+        #print "time",time.time()-T0,fitter._engine.__class__.__name__
+        
+        self.assert_(result1)
+        self.assertTrue(len(result1.pvec)>0)
+        self.assertTrue(len(result1.stderr)>0)
+
+        #print [z for z in zip(result1.param_list,result1.pvec,result1.stderr)]
+        self.assertTrue( math.fabs(result1.pvec[0]-399.8)/3.0 < result1.stderr[0] )
+        self.assertTrue( math.fabs(result1.pvec[1]-17.5)/3.0  < result1.stderr[1] )
+        self.assertTrue( math.fabs(result1.pvec[2]-11.1)/3.0   < result1.stderr[2] )
+        self.assertTrue( math.fabs(result1.pvec[3]-0.276)/3.0   < result1.stderr[3] )
+        self.assertTrue( result1.fitness < 1.0 )
+        
+        
+class smear_testdata(unittest.TestCase):
+    """
+        Test fitting with the smearing operations
+        The output of the fits should be compated to fits
+        done with IGOR for the same models and data sets.
+    """
+    def setUp(self):
+        data = Loader().load("latex_smeared.xml")
+        self.data_res = data[0]
+        self.data_slit = data[1]
+        
+        self.sphere = SphereModel()
+        self.sphere.setParam('background', 0)
+        self.sphere.setParam('radius', 5000.0)
+        self.sphere.setParam('scale', 0.4)
+        self.sphere.setParam('sldSolv',0)
+        self.sphere.setParam('sldSph',1e-6)
+        #self.sphere.setParam('radius.npts', 30)
+        #self.sphere.setParam('radius.width',50)
+
+    def test_reso(self):
+
+        # Let the data module find out what smearing the
+        # data needs
+        smear = smear_selection(self.data_res)
+        self.assertEqual(smear.__class__.__name__, 'QSmearer')
+
+        # Fit
+        fitter = Fit('scipy')
+        
+        # Data: right now this is the only way to set the smearer object
+        # We should improve that and have a way to get access to the
+        # data for a given fit.
+        fitter.set_data(self.data_res,1)
+        fitter._engine.fit_arrange_dict[1].data_list[0].smearer = smear
+
+        # Model: maybe there's a better way to do this.
+        # Ideally we should have to create a new model from our sans model.
+        fitter.set_model(Model(self.sphere),1, ['radius','scale', 'background'])
+        
+        # Why do we have to do this...?
+        fitter.select_problem_for_fit(id=1,value=1)
+
+        # Perform the fit (might take a while)
+        result1, = fitter.fit()
+        
+        #print "v",result1.pvec
+        #print "dv",result1.stderr
+        #print "chisq(v)",result1.fitness
+
+        self.assertTrue( math.fabs(result1.pvec[0]-5000) < 20 )
+        self.assertTrue( math.fabs(result1.pvec[1]-0.48) < 0.02 )
+        self.assertTrue( math.fabs(result1.pvec[2]-0.060)  < 0.002 )
+
+
+    def test_slit(self):
+        smear = smear_selection(self.data_slit)
+        self.assertEqual(smear.__class__.__name__, 'SlitSmearer')
+
+        fitter = Fit('scipy')
+        
+        # Data: right now this is the only way to set the smearer object
+        # We should improve that and have a way to get access to the
+        # data for a given fit.
+        fitter.set_data(self.data_slit,1)
+        fitter._engine.fit_arrange_dict[1].data_list[0].smearer = smear
+        fitter._engine.fit_arrange_dict[1].data_list[0].qmax = 0.003
+        
+        # Model
+        fitter.set_model(Model(self.sphere),1, ['radius','scale'])
+        fitter.select_problem_for_fit(id=1,value=1)
+        
+        result1, = fitter.fit()
+        
+        #print "v",result1.pvec
+        #print "dv",result1.stderr
+        #print "chisq(v)",result1.fitness
+        
+        self.assertTrue( math.fabs(result1.pvec[0]-2340) < 20 )
+        self.assertTrue( math.fabs(result1.pvec[1]-0.010) < 0.002 )
+
+if __name__ == '__main__':
+    unittest.main()
Index: test/park_integration/test/utest_park_scipy.py
===================================================================
--- test/park_integration/test/utest_park_scipy.py	(revision e544c84d2610bcd83dba5154fafcc4691034075a)
+++ test/park_integration/test/utest_park_scipy.py	(revision e544c84d2610bcd83dba5154fafcc4691034075a)
@@ -0,0 +1,59 @@
+"""
+    Unit tests for fitting module 
+    @author: G. Alina
+"""
+import unittest
+import math
+
+from sans.guiframe.dataFitting import Data1D 
+from sans.fit.AbstractFitEngine import Model,FitData1D
+from sans.fit.Fitting import Fit
+from sans.dataloader.loader import Loader
+from sans.models.MultiplicationModel import MultiplicationModel
+from sans.models.CylinderModel import CylinderModel
+from sans.models.SquareWellStructure import SquareWellStructure
+
+class testFitModule(unittest.TestCase):
+    """ test fitting """
+   
+        
+    def test_scipy(self):
+        """ Simple cylinder model fit (scipy)  """
+        
+        out=Loader().load("cyl_400_20.txt")
+        data = Data1D(x=out.x, y=out.y, dx=out.dx, dy=out.dy)
+        # Receives the type of model for the fitting
+        model1  =  MultiplicationModel(CylinderModel(),SquareWellStructure())
+        model1.setParam('background', 0.0)
+        model1.setParam('sldCyl', 3e-006)
+        model1.setParam('sldSolv', 0.0)
+        model1.setParam('length', 420)
+        model1.setParam('radius', 40)
+        model1.setParam('scale_factor', 2)
+        model1.setParam('volfraction', 0.04)
+        model1.setParam('welldepth', 1.5)
+        model1.setParam('wellwidth', 1.2)
+      
+        model = Model(model1)
+    
+        pars1 =['length','radius','scale_factor']
+        fitter = Fit('scipy')
+        fitter.set_data(data,1)
+        fitter.set_model(model,1,pars1)
+        fitter.select_problem_for_fit(id=1,value=1)
+        result1, = fitter.fit()
+
+        self.assert_(result1)
+        self.assertTrue(len(result1.pvec)>=0 )
+        self.assertTrue(len(result1.stderr)>= 0)
+
+        #print "results",list(zip(result1.pvec, result1.stderr))
+        self.assertTrue( math.fabs(result1.pvec[0]-612)/3.0 <= result1.stderr[0] )
+        self.assertTrue( math.fabs(result1.pvec[1]-20.3)/3.0  <= result1.stderr[1] )
+        self.assertTrue( math.fabs(result1.pvec[2]-25)/3.0 <= result1.stderr[2] )
+        
+        self.assertTrue( result1.fitness/len(data.x) < 1.0 )
+        
+       
+if __name__ == '__main__':
+    unittest.main()  
Index: test/park_integration/test/utest_small_test.py
===================================================================
--- test/park_integration/test/utest_small_test.py	(revision 76f132a28f8a87fc91ae4fe9b234ceda800fa202)
+++ test/park_integration/test/utest_small_test.py	(revision 76f132a28f8a87fc91ae4fe9b234ceda800fa202)
@@ -0,0 +1,42 @@
+"""
+    Unit tests for fitting module 
+"""
+import unittest
+import math
+from sans.fit.Fitting import Fit
+from sans.dataloader.loader import Loader
+
+class testFitModule(unittest.TestCase):
+    """ test fitting """
+    def test_park(self):
+        """ Simple cylinder model fit (scipy)  """
+        
+        out= Loader().load("cyl_400_20.txt")
+       
+        fitter = Fit('scipy')
+        # Receives the type of model for the fitting
+        from sans.models.CylinderModel import CylinderModel
+        model  = CylinderModel()
+        model.setParam('sldCyl', 1)
+        model.setParam('sldSolv', 0)
+
+        pars1 =['length','radius','scale']
+        fitter.set_data(out,1)
+        model.setParam('scale', 1e-10)
+        fitter.set_model(model,1,pars1, constraints=())
+        fitter.select_problem_for_fit(id=1,value=1)
+        result1, = fitter.fit()
+        #print result1
+        #print result1.__dict__
+
+        self.assert_(result1)
+        self.assertTrue(len(result1.pvec)>0 or len(result1.pvec)==0 )
+        self.assertTrue(len(result1.stderr)> 0 or len(result1.stderr)==0)
+        
+        #print result1.pvec[0]-400.0, result1.pvec[0]
+        #print math.fabs(result1.pvec[0]-400.0)/3.0
+        self.assertTrue( math.fabs(result1.pvec[0]-400.0)/3.0 < result1.stderr[0] )
+        self.assertTrue( math.fabs(result1.pvec[1]-20.0)/3.0  < result1.stderr[1] )
+        self.assertTrue( math.fabs(result1.pvec[2]-9.0e-12)/3.0   < result1.stderr[2] )
+        self.assertTrue( result1.fitness < 1.0 )
+        
Index: test/run_one.py
===================================================================
--- test/run_one.py	(revision 95fb3e8659be4e20c87d88465e68b8077488a368)
+++ test/run_one.py	(revision 76f132a28f8a87fc91ae4fe9b234ceda800fa202)
@@ -1,3 +1,4 @@
 #!/usr/bin/env python
+
 import os
 import sys
@@ -8,10 +9,9 @@
 
 run_py = joinpath(dirname(dirname(abspath(__file__))), 'run.py')
-#print run_py
 run = imp.load_source('sasview_run', run_py)
 run.prepare()
 #print "\n".join(sys.path)
-test_path,test_file = splitpath(sys.argv[1])
-print "test file",sys.argv[1]
+test_path,test_file = splitpath(abspath(sys.argv[1]))
+print "=== testing:",sys.argv[1]
 #print test_path, test_file
 sys.argv = [sys.argv[0]]
@@ -20,3 +20,2 @@
 test = imp.load_source('tests',test_file)
 unittest.main(test, testRunner=xmlrunner.XMLTestRunner(output='logs'))
-
